#!/bin/sh

#
# panicforpcl.sh
#
#  Description: panicforpcl service script
#
#  Copyright 2009, 2011  FUJITSU LIMITED
#
#  panicforpcl service script
#
#  chkconfig: - 18 82
#
#  Author: FUJITSU LIMITED
#

# Source function library.
. /etc/rc.d/init.d/functions

### define #######################################
FJSVFEFPCL_LOG="/var/log/FJSVfefpcl.log"
FJSVFEFPCL_LOCK="/var/lock/subsys/FJSVfefpcl"
FJSVFEFPCL_LOCK_2=".FJSVfefpcl"
KDUMP_CONFIG="/etc/kdump.conf"
FJSVFEFPCL_POST="/var/crash/scripts/fefpcl_post.sh"
EXT3_MOUNTPT=/mnt/fefpclwk
OK=0
NG=1
ON=1
OFF=0
### Message output proc START ###############################
LANG=C
UNAME=$(uname -r)
PID=$$
DATE=$(date +"%b %d %H:%M:%S")
ERR="ERROR"
INF="INFO"
WAR="WARNING"
MSG="MESSAGE"
DBG="DEBUG"
MSG_PROC() {
case "$2" in
$ERR)
	echo -e "$DATE $UNAME $1[$PID] $2:$3" >> $FJSVFEFPCL_LOG
	echo -e "$2:$3" >&2 ;;
$INF)
	echo -e "$DATE $UNAME $1[$PID] $2:$3" >> $FJSVFEFPCL_LOG
	echo -e "$2:$3" >&1 ;;
$WAR)
	echo -e "$DATE $UNAME $1[$PID] $2:$3" >> $FJSVFEFPCL_LOG
	echo -e "$2:$3" >&1 ;;
$MSG)
	echo -e "$DATE $UNAME $1[$PID] $2:" >> $FJSVFEFPCL_LOG
	echo -e "$3" >> $FJSVFEFPCL_LOG
	echo -e "$3" >&1 ;;
$DBG)
	echo -e "$DATE $UNAME $1[$PID] $2:$3" >> $FJSVFEFPCL_LOG ;;
*)
	echo -e "$DATE $UNAME $1[$PID] $2:$3" >> $FJSVFEFPCL_LOG
	echo -e "$3" >&1 ;;
esac
}
### Message output proc END   ###############################

#### load ############################################
load() {

modprobe panicforpcl > /dev/null 2>&1
retcd=$?
if [ $retcd -ne 0 ]; then
	MSG_PROC load $ERR "panicforpcl modprobe failed."
	return $retcd
fi

return $OK
}
#### unload ##########################################
unload() {

rmmod panicforpcl > /dev/null 2>&1
retcd=$?
if [ $retcd -ne 0 ]; then
	MSG_PROC unload $ERR "rmmod panicforpcl failed."
	return $retcd
fi

rmmod fefpcl > /dev/null 2>&1

return $OK
}
#### kdumpset ##############################################
kdumpset(){

if [ ! -f $KDUMP_CONFIG ]; then
	MSG_PROC kdumpset $ERR "kdump.conf is not found."
	return $NG
fi

local -i change_flg=$OFF
local -i write_flg=$OFF
local -i post_flg=$OFF
#local -i extra_flg=$OFF
#local wk_extra=""

touch $KDUMP_CONFIG.tmp
while read -r line; do

	write_flg=$OFF

	echo $line | grep "^kdump_post" > /dev/null 2>&1
	if [ $? -eq 0 ]; then
		post_flg=$ON
		echo $line | grep -v "$FJSVFEFPCL_POST" > /dev/null 2>&1
		if [ $? -eq 0 ]; then
			echo "kdump_post $FJSVFEFPCL_POST" >> $KDUMP_CONFIG.tmp
			change_flg=$ON
			write_flg=$ON
		fi
	fi

#	echo $line | grep "^extra_modules" > /dev/null 2>&1
#	if [ $? -eq 0 ]; then
#		extra_flg=$ON
#		wk_extra=""
#		echo $line | grep -v "panicforpcl" > /dev/null 2>&1
#		if [ $? -eq 0 ]; then
#			wk_extra="$wk_extra panicforpcl"
#		fi
#		if [ "x$wk_extra" != "x" ]; then
#			echo "$line $wk_extra" >> $KDUMP_CONFIG.tmp
#			change_flg=$ON
#			write_flg=$ON
#		fi
#	fi

	if [ $write_flg -eq $OFF ]; then
		echo "$line" >> $KDUMP_CONFIG.tmp
		write_flg=$ON
	fi
	
done < $KDUMP_CONFIG

if [ $post_flg -eq $OFF ]; then
	echo "kdump_post $FJSVFEFPCL_POST" >> $KDUMP_CONFIG.tmp
	change_flg=$ON
fi

#if [ $extra_flg -eq $OFF ]; then
#	echo "extra_modules panicforpcl" >> $KDUMP_CONFIG.tmp
#	change_flg=$ON
#fi

if [ $change_flg -eq $ON ]; then
	mv $KDUMP_CONFIG.tmp $KDUMP_CONFIG
else
	rm -f $KDUMP_CONFIG.tmp
fi

#FJSVFEFPCL_POST change
change_flg=$OFF
touch $FJSVFEFPCL_POST.tmp
while read -r line; do
	write_flg=$OFF
	echo $line | grep "^#!/bin/sh" > /dev/null 2>&1
	if [ $? -eq 0 ]; then
		echo "#!/bin/msh" >> $FJSVFEFPCL_POST.tmp
		change_flg=$ON
		write_flg=$ON
	fi
	if [ $write_flg -eq $OFF ]; then
		echo "$line" >> $FJSVFEFPCL_POST.tmp
		write_flg=$ON
	fi
done < $FJSVFEFPCL_POST

if [ $change_flg -eq $ON ]; then
	mv $FJSVFEFPCL_POST.tmp $FJSVFEFPCL_POST
	chmod 755 $FJSVFEFPCL_POST
else
	rm -f $FJSVFEFPCL_POST.tmp
fi

return $OK
}
#### kdumpunset ############################################
kdumpunset() {

# check lockfile
if [ -f $FJSVFEFPCL_LOCK ]; then
	stop
fi

if [ ! -f $KDUMP_CONFIG ]; then
	MSG_PROC kdumpunset $ERR "kdump.conf is not found."
	return $NG
fi

local -i change_flg=$OFF
local -i write_flg=$OFF
local -i post_flg=$OFF
#local -i extra_flg=$OFF
#local wk_extra=""

touch $KDUMP_CONFIG.tmp
while read -r line; do

	write_flg=$OFF

	echo $line | grep "^kdump_post" | grep "$FJSVFEFPCL_POST" > /dev/null 2>&1
	if [ $? -eq 0 ]; then
		change_flg=$ON
		write_flg=$ON
	fi

#	echo $line | grep "^extra_modules" | grep "panicforpcl" > /dev/null 2>&1
#	if [ $? -eq 0 ]; then
#		change_flg=$ON
#		write_flg=$ON
#		wk_extra=""
#		for mod in $line; do
#			if [ $mod != "panicforpcl" -a $mod != "extra_modules" ]; then
#				wk_extra="$wk_extra $mod"
#			fi
#		done
#		if [ "x$wk_extra" != "x" ]; then
#			echo "extra_modules $wk_extra" >> $KDUMP_CONFIG.tmp
#		fi
#	fi

	if [ $write_flg -eq $OFF ]; then
		echo "$line" >> $KDUMP_CONFIG.tmp
		write_flg=$ON
	fi
	
done < $KDUMP_CONFIG

if [ $change_flg -eq $ON ]; then
	mv $KDUMP_CONFIG.tmp $KDUMP_CONFIG
else
	rm -f $KDUMP_CONFIG.tmp
fi

return $OK
}
#### start #################################################
start() {

# check lockfile
if [ -f $FJSVFEFPCL_LOCK ]; then
	MSG_PROC start $INF "panicforpcl is already starting."
	return $OK
fi

#make lockfile
touch $FJSVFEFPCL_LOCK

#kernel modules load
load
retcd=$?
if [ $retcd -ne $OK ]; then
	rm -f $FJSVFEFPCL_LOCK
	return $retcd
fi

# kdump setup
kdumpset
if [ $? -ne $OK ]; then
	unload
	rm -f $FJSVFEFPCL_LOCK
	return $NG
fi

MSG_PROC start $INF "panicforpcl started."
return $OK
}
#### stop ##################################################
stop() {
# check kernel_module.
lsmod | grep -qw "panicforpcl"
rtn_lsmod=$?

if [ ! -f $FJSVFEFPCL_LOCK -a $rtn_lsmod -ne 0 ]; then
	MSG_PROC stop $INF "panicforpcl is already stopping."
	return $OK
fi

if [ $rtn_lsmod -eq $OK ]; then
	unload
	retcd=$?
	if [ $retcd -ne $OK ]; then
		return $retcd
	fi
fi

if [ -f $FJSVFEFPCL_LOCK ]; then
	rm -f $FJSVFEFPCL_LOCK
fi

MSG_PROC stop $INF "panicforpcl stoped."
return $OK
}
#### restart ###############################################
restart(){
stop
if [ $? -ne $OK ]; then
	return $NG
fi
start
if [ $? -ne $OK ]; then
	return $NG
fi
return $OK
}
#### status ################################################
status(){

# service status
if [ -f $FJSVFEFPCL_LOCK ]; then
	MSG_PROC status $MSG "panicforpcl enabled."
else
	MSG_PROC status $MSG "panicforpcl disabled."
fi

# panicforpcl
lsmod | grep -qw "panicforpcl"
if [ $? -eq 0 ]; then
	MSG_PROC status $MSG "panicforpcl is loaded."
else
	MSG_PROC status $MSG "panicforpcl is not loaded."
fi

# fefpcl
lsmod | grep -qw "fefpcl"
if [ $? -eq 0 ]; then
	MSG_PROC status $MSG "fefpcl is loaded."
else
	MSG_PROC status $MSG "fefpcl is not loaded."
fi

return $OK
}
#### usage #################################################
usage() {
MSG_PROC usage $MSG "\
Usage: panicforpcl.sh {subcommand}
start		start panicforpcl
stop		stop panicforpcl
restart		stop and start panicforpcl
status		show if panicforpcl is activated \
"
return $OK
}
###### MAIN proc ##########################################
case "$1" in
	start) start ;;
	restart) restart ;;
	stop) stop ;;
	status) status ;;
	kdumpunset) kdumpunset ;;
	*) usage ;;
esac

exit $?

